#include <imsls.h>

int main()
{

   int    n_groups = 5;
   int    n[] = {4, 4, 4, 4, 4};
   int    permute[] = {2, 3, 4, 0, 1};
   float  y[] = {41.0, 43.0, 42.0, 46.0, 42.0, 
                43.0, 46.0, 38.0, 27.0, 26.0,
                28.0, 27.0, 48.0, 45.0, 51.0,
                46.0, 28.0, 32.0, 37.0, 25.0};
   float  *anova_table, *ci_diff_means, tmp_diff_means[50];
   float  confidence = 99.0;
   char   *labels[] = {
                    "degrees of freedom for among groups",
                    "degrees of freedom for within groups",
                    "total (corrected) degrees of freedom",
                    "sum of squares for among groups",
                    "sum of squares for within groups",
                    "total (corrected) sum of squares",
                    "among mean square",
                    "within mean square", "F-statistic",
                    "p-value", "R-squared (in percent)",
                    "adjusted R-squared (in percent)",
                    "est. standard deviation of within error",
                    "overall mean of y",
                    "coefficient of variation (in percent)"};
   char   *mean_row_labels[] = {
                    "first and second",
                    "first and third",
                    "first and fourth",
                    "first and fifth",
                    "second and third",
                    "second and fourth",
                    "second and fifth",
                    "third and fourth",
                    "third and fifth",
                    "fourth and fifth"};
   char   *mean_col_labels[] = {
                    "Means",
                    "Difference of means",
                    "Lower limit",
                    "Upper limit"};
                        /* Perform analysis */
   
 imsls_f_anova_oneway(n_groups, n, y,
        IMSLS_ANOVA_TABLE, &anova_table, 
        IMSLS_CONFIDENCE, confidence, 
        IMSLS_TUKEY, &ci_diff_means,
        0);
                        /* Print anova_table */
   imsls_f_write_matrix("* * * Analysis of Variance * * *\n", 15, 
        1, anova_table, 
        IMSLS_ROW_LABELS, labels,
        IMSLS_WRITE_FORMAT, "%9.2f",
        0);
                      /* Permute ci_diff_means for printing */
   imsls_f_permute_matrix(10, 5, ci_diff_means, permute,
        IMSLS_PERMUTE_COLUMNS,
        IMSLS_RETURN_USER, tmp_diff_means,
        0);
                      /* Print ci_diff_means */
   imsls_f_write_matrix("* * * Differences in Means * * *\n", 10,
        3, tmp_diff_means,
        IMSLS_A_COL_DIM, 5,
        IMSLS_ROW_LABELS, mean_row_labels,
        IMSLS_COL_LABELS, mean_col_labels,
        IMSLS_WRITE_FORMAT, "11.4g",
        0);
}
